首页 > 代码库 > HDU 2639 Bone Collector II
HDU 2639 Bone Collector II
one Collector IITime Limit: 5000/2000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 2179 Accepted Submission(s): 1142
Problem Description
The title of this problem is familiar,isn‘t it?yeah,if you had took part in the "Rookie Cup" competition,you must have seem this title.If you haven‘t seen it before,it doesn‘t matter,I will give you a link:
Here is the link:http://acm.hdu.edu.cn/showproblem.php?pid=2602
Today we are not desiring the maximum value of bones,but the K-th maximum value of the bones.NOTICE that,we considerate two ways that get the same value of bones are the same.That means,it will be a strictly decreasing sequence from the 1st maximum , 2nd maximum .. to the K-th maximum.
If the total number of different values is less than K,just ouput 0.
Here is the link:http://acm.hdu.edu.cn/showproblem.php?pid=2602
Today we are not desiring the maximum value of bones,but the K-th maximum value of the bones.NOTICE that,we considerate two ways that get the same value of bones are the same.That means,it will be a strictly decreasing sequence from the 1st maximum , 2nd maximum .. to the K-th maximum.
If the total number of different values is less than K,just ouput 0.
Input
The first line contain a integer T , the number of cases.
Followed by T cases , each case three lines , the first line contain two integer N , V, K(N <= 100 , V <= 1000 , K <= 30)representing the number of bones and the volume of his bag and the K we need. And the second line contain N integers representing the value of each bone. The third line contain N integers representing the volume of each bone.
Followed by T cases , each case three lines , the first line contain two integer N , V, K(N <= 100 , V <= 1000 , K <= 30)representing the number of bones and the volume of his bag and the K we need. And the second line contain N integers representing the value of each bone. The third line contain N integers representing the volume of each bone.
Output
One integer per line representing the K-th maximum of the total value (this number will be less than 231).
Sample Input
3 5 10 2 1 2 3 4 5 5 4 3 2 1 5 10 12 1 2 3 4 5 5 4 3 2 1 5 10 16 1 2 3 4 5 5 4 3 2 1
Sample Output
12 2 0
Author
teddy
Source
百万秦关终属楚
题意:第k优解问题。
思路:记录每个状态的前k优解,然后去重,更新当前状态的第k优解。
AC代码:
#include <cstdio> #include <iostream> #include <algorithm> #include <cmath> #include <cstring> #include <stdlib.h> using namespace std; int a[105]; int dp[1005][35]; int va[105]; int vo[105]; bool cmp(int a,int b){ return a>b; } int main(){ int t; scanf("%d",&t); while(t--){ int k,n,m; scanf("%d%d%d",&n,&m,&k); for(int i=0;i<n;i++){ scanf("%d",&va[i]); } for(int i=0;i<n;i++){ scanf("%d",&vo[i]); } memset(dp,0,sizeof(dp)); for(int i=0;i<n;i++){ for(int j=m;j>=vo[i];j--){ int temp=0; for(int l=0;l<k;l++){ a[temp++]=dp[j][l]; a[temp++]=dp[j-vo[i]][l]+va[i]; } sort(a,a+k*2,cmp); temp=0; dp[j][0]=a[0]; for(int l=1;l<k*2&&temp<k;l++){ if(a[l]!=a[l-1]){ dp[j][++temp]=a[l]; } } } } if(k==0) printf("0\n"); else printf("%d\n",dp[m][k-1]); } return 0; }
声明:以上内容来自用户投稿及互联网公开渠道收集整理发布,本网站不拥有所有权,未作人工编辑处理,也不承担相关法律责任,若内容有误或涉及侵权可进行投诉: 投诉/举报 工作人员会在5个工作日内联系你,一经查实,本站将立刻删除涉嫌侵权内容。